stages:
  - build
  - test

image: node:17

include:
  - template: Security/SAST.gitlab-ci.yml

# Cache modules in between jobs
cache:
  key: ${CI_COMMIT_REF_SLUG}
  paths:
  - node_modules/

 
build_app:
  stage: build
  before_script:
    - export NODE_OPTIONS=--openssl-legacy-provider
  script:
    - yarn install
    - yarn upgrade
    - yarn run build
    - yarn cache clean

unit_test:
  stage: test
  before_script:
    - yarn add chai mocha mocha-simple-html-reporter mocha-junit-reporter chai-http mocha-test-url

  script:
    - ./node_modules/mocha/bin/_mocha "test/*.js" --reporter mocha-junit-reporter --reporter-options mochaFile=./testresults/test-results.xml
    - ./node_modules/mocha/bin/_mocha "test/*.js" --reporter mocha-simple-html-reporter --reporter-options output=./testresults/test-results.html

  after_script:
    - echo "build_app job has run!"

  needs: []

  rules:
  - if: $CI_COMMIT_BRANCH == 'main'

code_quality:
  stage: test
  script:
    -  echo "This will run code quality in the future"
    -  exit 1
  ### This job can run independently of any previous job completion, i.e. build job, in order to execute
  needs: []
  rules:
    - if: $CI_COMMIT_BRANCH == 'main'
      allow_failure: true



